<!-- 版本列表 -->

<template>
  <div style="position: relative">
    <el-button class="add" type="primary" icon="el-icon-plus" :size="defaultFormItemSize" @click="add()">新增版本</el-button>
    <vxe-table border show-header-overflow show-overflow :row-config="{ isHover: true }"
      :data="myDataSetPage.tableData.impl.dataList" min-height="96">
      <vxe-column field="modelVersion" title="版本号">
        <template slot-scope="scope">
          V{{ scope.row.modelVersion }}
        </template>
      </vxe-column>
      <vxe-column field="status" title="版本状态">
        <template slot-scope="scope">
          {{ VersionStatus.getValue(scope.row.status) }}
        </template>
      </vxe-column>
      <vxe-column field="versionSource" title="版本来源"></vxe-column>
      <vxe-column field="baseModel" title="基础模型"></vxe-column>
      <vxe-column field="versionDescribe" title="版本描述"></vxe-column>
      <vxe-column field="createTime" title="创建时间"></vxe-column>
      <vxe-column field="operation" title="操作">
        <template slot-scope="scope">
        
          <el-button type="text" :size="defaultFormItemSize" @click="particulars(scope.row)">详情</el-button>
          <el-button type="text" :size="defaultFormItemSize" @click="assess(scope.row)">评估</el-button>
          <el-button type="text" v-if="scope.row.isCompress==0" :size="defaultFormItemSize" @click="compress(scope.row)">压缩</el-button>
          <el-button type="text" :size="defaultFormItemSize" >部署</el-button>
          <el-button type="text" :size="defaultFormItemSize" @click="del(scope.row)">删除</el-button>
        </template>
      </vxe-column>
    </vxe-table>
    <el-row slot="pagination" type="flex" justify="end" style="margin-top: 16px;">
      <el-pagination :total="myDataSetPage.tableData.impl.totalCount"
        :current-page="myDataSetPage.tableData.impl.currentPage" :page-size="myDataSetPage.tableData.impl.pageSize"
        :page-sizes="[10, 20, 50, 100]" layout="total, prev, pager, next, sizes"
        @current-change="myDataSetPage.tableData.impl.onCurrentPageChange"
        @size-change="myDataSetPage.tableData.impl.onPageSizeChange">
      </el-pagination>
    </el-row>

  </div>
</template>
  
<script>
import { mapGetters } from 'vuex';
/* eslint-disable-next-line */
import { DropdownWidget, TableWidget, UploadWidget, ChartWidget } from '@/utils/widget.js';
import { ModelVersion } from '@/api/gptController.js';
import editOrAdd from './dialog/editOrAdd';
import particulars from './dialog/particulars';
import addAssess from '@/views/gptTraining/modelManagement/modelEvaluation/dialog/editOrAdd.vue';
import addCompress from '@/views/gptTraining/modelManagement/modelCompression/dialog/editOrAdd.vue';

export default {
  data () {
    return {
      myDataSetPage: {
        formFilter: {
  
        },

        tableData: {
          impl: new TableWidget(this.getwidgetData, true, true, false, undefined, false)
        }
      }
    };
  },

  components: {},
  props: ['tableItem'],
  computed: {
    ...mapGetters(['getMainContextHeight']),
    tableHeight () {
      return this.getMainContextHeight - 95 + 'px';
    }

  },

  methods: {
    getwidgetData (params) {
      if (params == null) params = {};
      params = {
        ...params,
        orderParam: [
          {
            asc: true,
            dateAggregateBy: '',
            fieldName: ''
          }
        ],
        // pageParam: {
        //   pageNum: 0,
        //   pageSize: 0
        // },
        
        modelVersionDtoFilter: {modelId: this.tableItem.modelId }
      }

      return new Promise((resolve, reject) => {
        ModelVersion.list(this, params).then(res => {
          resolve({
            dataList: res.data.dataList,
            totalCount: res.data.totalCount
          });
        }).catch(e => {
          reject(e);
        });
      });
    },
    assess (item) {
      this.$dialog.show('评估', addAssess, {
        area: ['100%', '100%']
      }, {modelVersionId: item.versionId}).then(res => {
        this.refresh();
        this.$emit('assessRefresh')
      }).catch(e => { });
    },
    compress (item) {
      console.log(item.versionId);
      this.$dialog.show('压缩', addCompress, {
        area: ['100%', '100%']
      }, {modelVersionId: item.versionId}).then(res => {
        this.refresh();
        this.$emit('assessRefresh')
      }).catch(e => { });
    },

    add () {
      console.log(this.myDataSetPage.tableData.impl.dataList.slice(-1)[0].modelVersion);
      this.$dialog.show('新增版本', editOrAdd, {
        area: ['100%', '100%']
      }, { tableItem: this.tableItem, versionIndex: this.myDataSetPage.tableData.impl.dataList.slice(-1)[0].modelVersion}).then(res => {
        this.refresh();
        this.$emit('assessRefresh')
      }).catch(e => { });
    },
    edit (item) {
      this.$dialog.show('修改模版', editOrAdd, {
        area: ['100%', '100%']
      }, { isEdit: true, item: item }).then(res => {
        this.refresh();
      }).catch(e => { });
    },
    del (item) {
      this.$confirm('是否确认删除', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        let params = { versionId: item.versionId }
        ModelVersion.delete(this, params).then(res => {
          this.$message.success('删除成功');
          this.refresh()
        }).catch(e => {
          console.log(e);
        });
      })
    },
    particulars (item) {
      this.$dialog.show('详情', particulars, {
        area: ['100%', '100%']
      }, { item: item }).then(res => {
        this.refresh();
      }).catch(e => { });
    },
    refresh (reloadData = false) {
      if (reloadData) {
        this.myDataSetPage.tableData.impl.refreshTable(true, 1);
      } else {
        this.myDataSetPage.tableData.impl.refreshTable();
      }
    },
    onReset () {
      this.$refs.myDataSetPage.resetFields();
      this.refresh(true);
    },
    formInit () {
      this.refresh();
    }

  },

  mounted () {
    this.formInit()
  }

};
</script>
<style lang="scss" scoped>
@import "@/assets/style/element-variables.scss";

.topBox {
  background-color: white;
  width: 100%;
  height: 95px;
  margin-bottom: 16px;

  .title {
    color: $--color-text-primary;
    font-size: 16px;
    font-weight: 500;
    margin-bottom: 8px;
    padding: 20px 20px 10px 20px;
  }
}

.instructions {
  padding: 0px 20px 20px 20px;

  .describe {
    color: $--color-text-secondary;
    margin-bottom: 16px;
  }

  .itemTitle {
    color: $--color-text-primary;
    font-size: 16px;
    font-weight: 500;
    margin-bottom: 8px;
  }

  .head-index {
    font-size: 24px;
    color: #e8e9eb;
    line-height: 32px;
  }

  .itemDescribe {
    width: 170px;
    color: $--color-text-secondary;
  }

  .img {
    height: 72px;
    width: 140px;
  }
}

.tableBox {
  background-color: white;
  width: 100%;
  padding: 20px;
  overflow: auto;
  .add {
    margin-bottom: 20px;
  }
}
</style>
